<?php
/*
File: inc/assets.php
Description: Assets inclusion
Plugin: Imager
Author: Alessio Marzo
*/



//********************************************************************************//
// CSS
//********************************************************************************//


// Frontend
add_action( 'wp_enqueue_scripts', 'im_frontend_styles' );

function im_frontend_styles() {
	
	
	// Main
	wp_register_style( 'im-main-style',  IM_URL . 'assets/css/frontend.css' );
    wp_enqueue_style( 'im-main-style' );
	
	
	// Fonts
	wp_register_style( 'im-fonts-style',  IM_URL . 'assets/css/fonts.css' );
    wp_enqueue_style( 'im-fonts-style' );
	
	
	// Global Filter
	require_once(IM_DIR.'inc/filters.php');	
	
	$choosen_filter = get_option('im_global_filter');
	
	if(!empty($choosen_filter)){$custom_css = 'img { '.$im_filters_db[$choosen_filter].'}';}else{$custom_css = '';}
	
	wp_add_inline_style( 'im-main-style', $custom_css ); 
	
}


// Backend
add_action( 'admin_enqueue_scripts', 'im_backend_styles' );

function im_backend_styles() {
	
	// Main
	wp_register_style( 'im-backend-style',  IM_URL . 'assets/css/backend.css' );
    wp_enqueue_style( 'im-backend-style' );
	
	// Media
	wp_enqueue_style('thickbox');
	
}



//********************************************************************************//
// JS
//********************************************************************************//


// Frontend
add_action('wp_enqueue_scripts', 'im_frontend_scripts');

function im_frontend_scripts() {
	
	// Load WP jQuery if not included
	wp_enqueue_script('jquery');
	
	// Load main js script
	wp_register_script('im-frontend-script', IM_URL . 'assets/js/frontend.js', array('jquery'), '', true);
	wp_enqueue_script('im-frontend-script');
	
	// Load watermark js
	wp_register_script('im-watermark-lib', IM_URL . 'assets/js/watermark.jquery.min.js', array('jquery'), '', true);
	wp_enqueue_script('im-watermark-lib');
	
	/* Codex
	wp_register_script( $handle, $src, $deps, $ver, $in_footer );
	*/
	
}

// Watermark
add_action( 'wp_footer', 'im_watermark_init', 100, 1 );

function im_watermark_init() {
	if ( wp_script_is( 'jquery', 'done' ) ) {
	?>
	<script>
	
	/* Imager Watermark */
	
		jQuery(function($){
			$(document).ready(function() { 
		
				var config = {
				"opacity": <?php echo get_option('im_watermark_op');?>,
				"className": "watermark",
				"position": "<?php echo get_option('im_watermark_pos');?>",
				"path": "<?php echo get_option('im_watermark');?>" };
				
				$(document).watermark(config);
			
			});
		});
		
	</script>
    <?php
    }
}

// Backend
add_action('admin_enqueue_scripts', 'im_backend_scripts');

function im_backend_scripts() {
	
	// Load WP jQuery if not included
	wp_enqueue_script('jquery');
	
	// Load main js script	
	wp_register_script('im-backend-script', IM_URL . 'assets/js/backend.js', array('jquery'), '', true);
	wp_enqueue_script('im-backend-script');
	
	if ( isset($_GET['post_type']) && $_GET['post_type'] == 'imager' ) {
		
		// Load Watermark functions
		wp_register_script('im-water-functions', IM_URL . 'assets/js/watermark.js', array('jquery'), '', true);
		wp_enqueue_script('im-water-functions');
		
		// Media
		wp_enqueue_script('media-upload');
		wp_enqueue_script('thickbox');
	}
	
}