<?php
/*
File: inc/functions.php
Description: Plugin functions
Plugin: Imager
Author: Alessio Marzo
*/


// INCLUDE MEGA-FUNCTIONS FRAMEWORK
require_once(IM_DIR.'inc/mega-functions.php');

// Add image sizes
$sizes_args = array( 'post_type' => 'imager', 'posts_per_page' => -1 );
$sizes_loop = get_posts( $sizes_args );										
										
										
foreach ($sizes_loop as $size) {
											
	$name = get_post_meta( $size->ID, 'im_meta_name', true );
	$width = get_post_meta( $size->ID, 'im_meta_width', true );
	$height = get_post_meta( $size->ID, 'im_meta_height', true );
	$crop = get_post_meta( $size->ID, 'im_meta_crop', true );
	if($crop == 1 ){ 
	
		add_image_size( $name, $width, $height, $crop );
	
	}else{
		
		if(!empty($width) && empty($height)){
		add_image_size( $name, $width); 
		}
		if(!empty($height) && empty($width)){
		add_image_size( $name, $width, $height); 
		}
		
	}							
	
											
}

add_filter( 'image_size_names_choose', 'im_add_image_sizes_to_list');  

function im_add_image_sizes_to_list( $sizes ) {  

    $custom_sizes = array(); 

   	$sizes_args = array( 'post_type' => 'imager', 'posts_per_page' => -1 );
	$sizes_loop = get_posts( $sizes_args );		
	
	foreach ($sizes_loop as $size) {
											
	$name = get_post_meta( $size->ID, 'im_meta_name', true );
	$title = get_the_title($size->ID);
	$custom_sizes[$name] = $title;
											
	}
	
    return array_merge( $sizes, $custom_sizes );  
	
}


// CREATE ATTACHMENT FIELDS

add_filter( 'attachment_fields_to_edit', 'im_attachment_fields', 10, 2 );

function im_attachment_fields( $form_fields, $post ) {
	
	// Title
	$form_fields["im_title"]["label"] = '<h3 class="im_title">Imager Options</h3>';
	$form_fields["im_title"]["input"] = "html";
	$form_fields["im_title"]["html"] = "&nbsp;";
	
	// Filter
	$form_fields["im_filter"]["label"] = __('<span class="im_label">Filter</span>', IM_PLG_NAME);
	$form_fields["im_filter"]["input"] = "html";
	$form_fields["im_filter"]["html"] = "
	<select class='im_filters' name='attachments[{$post->ID}][im_filter]' id='attachments[{$post->ID}][im_filter]'>
		<option value='0' selected='selected'>None</option>
		<option value='im_greyscale_50'>Grey Scale (50%)</option>
		<option value='im_greyscale_75'>Grey Scale (75%)</option>
		<option value='im_greyscale_100'>Grey Scale (100%)</option>
		<option value='im_blur_light'>Blur (light)</option>
		<option value='im_blur_normal'>Blur (normal)</option>
		<option value='im_blur_hard'>Blur (hard)</option>
		<option value='im_sepia_50'>Sepia (50%)</option>
		<option value='im_sepia_75'>Sepia (75%)</option>
		<option value='im_sepia_100'>Sepia (100%)</option>
		<option value='im_desaturate_50'>Desaturation (50%)</option>
		<option value='im_desaturate_0'>Desaturation (100%)</option>
		<option value='im_saturate_50'>Saturation (50%)</option>
		<option value='im_saturate_100'>Saturation (100%)</option>
		<option value='im_darkness_50'>Darkness (50%)</option>
		<option value='im_darkness_75'>Darkness (75%)</option>
		<option value='im_brightness_50'>Brightness (50%)</option>
		<option value='im_brightness_100'>Brightness (100%)</option>
		<option value='im_lesscontrast_50'>Less Contrast (50%)</option>
		<option value='im_lesscontrast_75'>Less Contrast (75%)</option>
		<option value='im_morecontrast_50'>More Contrast (50%)</option>
		<option value='im_morecontrast_100'>More Contrast (100%)</option>
		<option value='im_huerotate_45'>Hue Rotate (45°)</option>
		<option value='im_huerotate_90'>Hue Rotate (90°)</option>
		<option value='im_huerotate_135'>Hue Rotate (135°)</option>
		<option value='im_huerotate_180'>Hue Rotate (180°)</option>
		<option value='im_huerotate_225'>Hue Rotate (225°)</option>
		<option value='im_huerotate_270'>Hue Rotate (270°)</option>
		<option value='im_huerotate_315'>Hue Rotate (315°)</option>
		<option value='im_opacity_30'>Opacity (30%)</option>
		<option value='im_opacity_60'>Opacity (60%)</option>
		<option value='im_opacity_90'>Opacity (90%)</option>
	</select>";
	
	// Mouse Over
	$form_fields["im_hover"]["label"] =  __('<span class="im_label">Mouse Over</span>', IM_PLG_NAME);
	$form_fields["im_hover"]["input"] = "html";
	$form_fields["im_hover"]["html"] = "
	<select class='im_hover' name='attachments[{$post->ID}][im_hover]' id='attachments[{$post->ID}][im_hover]'>
		<option value='0' selected='selected'>None</option>
		<option value='remove-filter'>Remove Filter</option>
	</select>";
	
	// Watermark
	$form_fields["im_water"]["label"] =  __('<span class="im_label">Watermark</span>', IM_PLG_NAME);
	$form_fields["im_water"]["input"] = "html";
	$form_fields["im_water"]["html"] = "
	<select class='im_water' name='attachments[{$post->ID}][im_water]' id='attachments[{$post->ID}][im_water]'>
		<option value='0' selected='selected'>Disabled</option>
		<option value='watermark'>Enabled</option>
	</select>";
	
	// Animation
	$form_fields["im_animation"]["label"] = __('<span class="im_label">Animation</span>', IM_PLG_NAME);
	$form_fields["im_animation"]["input"] = "html";
	$form_fields["im_animation"]["helps"] = __('<em class="im_help">The image will do the animation during its loading in the page.</em>', IM_PLG_NAME);
	$form_fields["im_animation"]["html"] = "
	<select class='im_animations' name='attachments[{$post->ID}][im_animation]' id='attachments[{$post->ID}][im_animation]'>
		<option value='0' selected='selected'>None</option>
		<option value='flash'>flash</option>
		<option value='shake'>shake</option>
		<option value='bounce'>bounce</option>
		<option value='tada'>tada</option>
		<option value='swing'>swing</option>
		<option value='wobble'>wobble</option>
		<option value='pulse'>pulse</option>
		<option value='flipInX'>flipInX</option>
		<option value='fadeIn'>fadeIn</option>
		<option value='fadeInUp'>fadeInUp</option>
		<option value='fadeInDown'>fadeInDown</option>
		<option value='fadeInLeft'>fadeInLeft</option>
		<option value='fadeInRight'>fadeInRight</option>
		<option value='fadeInUpBig'>fadeInUpBig</option>
		<option value='fadeInRightBig'>fadeInRightBig</option>
		<option value='slideInDown'>slideInDown</option>
		<option value='slideInLeft'>slideInLeft</option>
		<option value='slideInRight'>slideInRight</option>
		<option value='bounceIn'>bounceIn</option>
		<option value='bounceInUp'>bounceInUp</option>
		<option value='bounceInDown'>bounceInDown</option>
		<option value='bounceInLeft'>bounceInLeft</option>
		<option value='bounceInRight'>bounceInRight</option>
		<option value='rotateIn'>rotateIn</option>
		<option value='rotateInUpLeft'>rotateInUpLeft</option>
		<option value='rotateInDownLeft'>rotateInDownLeft</option>
		<option value='rotateInUpRight'>rotateInUpRight</option>
		<option value='rotateInDownRight'>rotateInDownRight</option>
		<option value='lightSpeedIn'>lightSpeedIn</option>
		<option value='rollIn'>rollIn</option>	
	</select>";

	return $form_fields;
}


// SAVE ATTACHMENT FIELDS

add_filter( 'attachment_fields_to_save', 'im_save_attachment_fields', 10, 2 );

function im_save_attachment_fields( $post, $attachment ) {
	
		
	if( isset( $attachment['im_filter'] ) ) {
		update_post_meta( $post['ID'], 'im_filter', $attachment['im_filter'] );
	}else{
		delete_post_meta( $post['ID'], 'im_filter' );
	}
	
		
	if( isset( $attachment['im_hover'] ) ) {
		update_post_meta( $post['ID'], 'im_hover', $attachment['im_hover'] );
	}else{
		delete_post_meta( $post['ID'], 'im_hover' );
	}
	
	if( isset( $attachment['im_water'] ) ) {
		update_post_meta( $post['ID'], 'im_water', $attachment['im_water'] );
	}else{
		delete_post_meta( $post['ID'], 'im_water' );
	}
	
	
	if( isset( $attachment['im_animation'] ) ) {
		update_post_meta( $post['ID'], 'im_animation', $attachment['im_animation'] );
	}else{
		delete_post_meta( $post['ID'], 'im_animation' );
	}

	return $post;
	
}

// SEND TO EDITOR
add_filter( 'media_send_to_editor', 'im_send_to_editor', 10, 3 );

function im_send_to_editor( $html, $id, $attachment ) {
	
	$im_filter = get_post_meta( $id, 'im_filter', true );
	if(!empty($im_filter)){ $im_filter = $im_filter.' '; }else{ $im_filter = '';}
	
	$im_hover = get_post_meta( $id, 'im_hover', true );
	if(!empty($im_hover)){ $im_hover = $im_hover.' '; }else{ $im_hover = '';}
	
	$im_water = get_post_meta( $id, 'im_water', true );
	if(!empty($im_water)){ $im_water = $im_water.' '; }else{ $im_water = '';}
	
	$im_animation = get_post_meta( $id, 'im_animation', true );
	if(!empty($im_animation)){ $im_animation = 'animated '.$im_animation.' '; }else{$im_animation = '';}

	delete_post_meta( $id, 'im_filter' );
	delete_post_meta( $id, 'im_animation' );
	delete_post_meta( $id, 'im_hover' );
	delete_post_meta( $id, 'im_water' );
	
	return str_replace('class="', 'class="'.$im_water.$im_filter.$im_hover.$im_animation, $html); 
	
}
