<?php
/*
File: inc/install.php
Description: Install functions
Plugin: Imager
Author: Alessio Marzo
*/


//***************************************************************************
// Options Install/Unistall
//***************************************************************************

register_activation_hook(__FILE__,'im_install_options');
register_deactivation_hook(__FILE__, 'im_uninstall_options');


// Install Options Function
function im_install_options() {
	
	// Force to uninstall past options
    im_uninstall_options();
	
	// Add the options
	add_option('im_global_filter','');
	
	// Update the revrite rules on activation
	flush_rewrite_rules();
	
}

// Uninstall Options Function
function im_uninstall_options() { 

	// Remove Options
	delete_option('im_global_filter');
	
	// Update the revrite rules on deactivation
	flush_rewrite_rules();
	
}



//***************************************************************************
// Plugin INIT
//***************************************************************************


// LANGUAGE
add_action('init', 'im_language');

function im_language() {
	
	load_plugin_textdomain('im', false, IM_DIR . '/languages/'); 
	
}

// FUNCTIONS
require_once(IM_DIR.'inc/functions.php'); 

// ASSETS
require_once(IM_DIR.'inc/assets.php');

// POST TYPES
require_once(IM_DIR.'inc/posttypes/imager.php');

// MENUS
require_once(IM_DIR.'inc/menus.php');

// META BOXES
require_once(IM_DIR.'inc/metaboxes.php');

// SHORTCODES
require_once(IM_DIR.'inc/shortcodes.php');

// UPDATE LIBRARY
require_once(IM_DIR.'inc/update-notifier.php');

// REGENERATE THUMBNAILS
require_once(IM_DIR.'regenerate-thumbnails/regenerate-thumbnails.php');
