<?php
/*
File: inc/metaboxes.php
Description: Plugin metaboxes
Plugin: Imager
Author: Alessio Marzo
*/


// CREATE METABOXES & METAFIELDS

add_action('admin_menu', 'im_metaboxes');

function im_metaboxes() {
	
	// BASIC METAS
	
	$screens_basic = array( 'imager' );
	
	foreach ( $screens_basic as $screen ) {
	add_meta_box('imager-desc-metabox', __('Short Description', IM_PLG_NAME), 'im_desc_metafields', $screen, 'normal', 'high');
	add_meta_box('imager-size-metabox', __('Image Size', IM_PLG_NAME), 'im_size_metafields', $screen, 'normal', 'high');
	}
	
	
}


// CREATE METAFIELDS
function im_desc_metafields() { 

	global $post;
	
	// Get all post meta saved
	$im_meta_desc = get_post_meta($post->ID, 'im_meta_desc', true);

	echo '<textarea name="im_meta_desc" id="im_meta_desc" class="excerpt">'.$im_meta_desc.'</textarea>
	<p>'.__('This description is only a remind for you.', IM_PLG_NAME).'</p>';
		 	
}

function im_size_metafields() { 

	global $post;
	
	// Get all post meta saved
	$im_meta_name = get_post_meta($post->ID, 'im_meta_name', true);
	$im_meta_width = get_post_meta($post->ID, 'im_meta_width', true);
	$im_meta_height = get_post_meta($post->ID, 'im_meta_height', true);
	$im_meta_crop = get_post_meta($post->ID, 'im_meta_crop', true);
	
	// Check if they exist
	if(empty($im_meta_name)){$im_meta_name = 'imager_size_'.rand(1000,9999);}
	if(empty($im_meta_width)){$im_meta_width = '';}
	if(empty($im_meta_height)){$im_meta_height = '';}
	if(empty($im_meta_crop)){$im_meta_crop = '0';}
	
	
	echo 'Name: <input type="text" name="im_meta_name" id="im_meta_name" value="'.$im_meta_name.'"><br>';
	echo '<p>'.__('Size name is needed so if you leave it blank plugin will create a random name for you (<b>use only [a-z] chars separated by _ </b>).', IM_PLG_NAME).'</p>';
	
	echo 'Width: <input type="text" name="im_meta_width" id="im_meta_width" value="'.$im_meta_width.'">';
	echo 'Height: <input type="text" name="im_meta_height" id="im_meta_height" value="'.$im_meta_height.'">';
	if(!empty($im_meta_crop)){echo '<input type="checkbox" checked="checked" name="im_meta_crop" id="im_meta_crop" value="1"> Crop the image<br>';}else{echo '<input type="checkbox" name="im_meta_crop" id="im_meta_crop" value="1"> Crop the image<br>';}	
	echo '<p>'.__('If you check Crop feature wordpress will cut your images at the desired size.', IM_PLG_NAME).'</p>';
		 	
}


// SAVE METAFIELDS

add_action('save_post', 'im_save_meta');

function im_save_meta($post_id, $post = null) {	

	$mf = new MF();
	
	if ( isset( $_REQUEST['im_meta_desc'] ) ) {
	
	$im_meta_desc = $_REQUEST['im_meta_desc'];	
	update_post_meta($post_id, 'im_meta_desc', $im_meta_desc);
	
	}
	
	if ( isset( $_REQUEST['im_meta_name'] ) ) {
	
	$im_meta_name = $_REQUEST['im_meta_name'];	
	update_post_meta($post_id, 'im_meta_name', $mf->sanitize_string($im_meta_name));
	
	}
	
	if ( isset( $_REQUEST['im_meta_width'] ) ) {
	
	$im_meta_width = $_REQUEST['im_meta_width'];	
	update_post_meta($post_id, 'im_meta_width', $im_meta_width);
	
	}
	
	if ( isset( $_REQUEST['im_meta_height'] ) ) {
	
	$im_meta_height = $_REQUEST['im_meta_height'];	
	update_post_meta($post_id, 'im_meta_height', $im_meta_height);
	
	}
	
	if ( isset($_REQUEST['im_meta_crop']) && $_REQUEST['im_meta_crop'] == 1 ) {
	
	update_post_meta($post_id, 'im_meta_crop', '1');
	
	}else{
		
	update_post_meta($post_id, 'im_meta_crop', '0');
	
	}
	
	
}
